import React, { Component } from 'react'
import { GoogleLogin, GoogleLogout } from 'react-google-login';

const clientId = `${process.env.REACT_APP_GOOGLE_CLIENT_ID}.apps.googleusercontent.com`;

export default class Session extends Component {
    constructor(props) {
        super(props)

        this.state = {
            logIn: false
        }

        this.loginSuccess = this.loginSuccess.bind(this)
        this.loginFailed = this.loginFailed.bind(this)
        this.logOutSuccess = this.logOutSuccess.bind(this)
    }

    // componentDidMount(){
    //     this.props.logOut()
    // }

    loginSuccess = (response) => {
        const {accessToken, tokenId, googleId: userId, profileObj} = response
        const {email, familyName: lastName, givenName: firstName} = profileObj
        const userResponse = {idToken: tokenId, userId, email, firstName, lastName, accessToken}
        this.props.login(userResponse)
        this.setState({logIn: true})
    }

    loginFailed = (response) => {
        console.log('Login failed: res:', response);
    }

    logOutSuccess = (response) => {
        this.props.logOut()
        this.setState({logIn: false})
    }
    
    render() {
        return (
            <div>
                {console.log(this.props.currentUser)}
                {!this.state.logIn ? 
                    <GoogleLogin
                        clientId={clientId}
                        buttonText="Login"
                        onSuccess={this.loginSuccess}
                        onFailure={this.loginFailed}
                        cookiePolicy={'single_host_origin'}
                /> :  <GoogleLogout
                        clientId={clientId}
                        buttonText="Logout"
                        onLogoutSuccess={this.logOutSuccess}
                    ></GoogleLogout>
                }
            </div>
        )
    }
}
